# CVE-2024-29847
POC for CVE-2024-29847 affecting Ivanti EPM.

## Technical Analysis
A technical root cause analysis of the vulnerability can be found on our blog:
https://www.horizon3.ai/attack-research/attack-blogs/cve-2024-29847-deep-dive-ivanti-endpoint-manager-agentportal-deserialization-of-untrusted-data-remote-code-execution-vulnerability

## Summary
This POC abuses a vulnerability in `AgentPortal.exe` to execute arbitrary commands. In order for this POC to work, you
must provide your own references to `AgentPortal.exe` and `APCommon.dll` from an Ivanti EPM installation.

## Usage
```plaintext
CVE-2024-29847.exe 192.168.1.21 49668 whoami.exe
Sending request.
Request result: True
Waiting for result.
Waiting for result.
Result: nt authority\system
```

## Mitigations
Update to the latest version or mitigate by following the instructions within the Ivanti Advisory
* https://forums.ivanti.com/s/article/Security-Advisory-EPM-September-2024-for-EPM-2024-and-EPM-2022?language=en_US

## Follow the Horizon3.ai Attack Team on Twitter for the latest security research:
*  [Horizon3 Attack Team](https://twitter.com/Horizon3Attack)
*  [James Horseman](https://twitter.com/JamesHorseman2)
*  [Zach Hanley](https://twitter.com/hacks_zach)

## Disclaimer
This software has been created purely for the purposes of academic research and for the development of effective defensive techniques, and is not intended to be used to attack systems except where explicitly authorized. Project maintainers are not responsible or liable for misuse of the software. Use responsibly.
